Index: lemon/base.cc
===================================================================
--- lemon/base.cc	(revision 39)
+++ lemon/base.cc	(revision 7)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/invalid.h
===================================================================
--- lemon/bits/invalid.h	(revision 39)
+++ lemon/bits/invalid.h	(revision 13)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/bits/utility.h
===================================================================
--- lemon/bits/utility.h	(revision 39)
+++ lemon/bits/utility.h	(revision 7)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/concept_check.h
===================================================================
--- lemon/concept_check.h	(revision 39)
+++ lemon/concept_check.h	(revision 27)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/concepts/maps.h
===================================================================
--- lemon/concepts/maps.h	(revision 39)
+++ lemon/concepts/maps.h	(revision 35)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/dim2.h
===================================================================
--- lemon/dim2.h	(revision 42)
+++ lemon/dim2.h	(revision 15)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -534,8 +534,8 @@
 
 
-  ///Map of x-coordinates of a Point map
-
-  ///\ingroup maps
-  ///Map of x-coordinates of a \ref dim2::Point "Point"-map.
+  ///Map of x-coordinates of a \ref Point "Point"-map
+
+  ///\ingroup maps
+  ///Map of x-coordinates of a \ref Point "Point"-map.
   ///
   template<class M>
@@ -571,5 +571,5 @@
   }
 
-  ///Constant (read only) version of XMap
+  ///Constant (read only) version of \ref XMap
 
   ///\ingroup maps
@@ -601,5 +601,5 @@
   }
 
-  ///Map of y-coordinates of a Point map
+  ///Map of y-coordinates of a \ref Point "Point"-map
     
   ///\ingroup maps
@@ -638,5 +638,5 @@
   }
 
-  ///Constant (read only) version of YMap
+  ///Constant (read only) version of \ref YMap
 
   ///\ingroup maps
@@ -669,6 +669,6 @@
 
 
-    ///\brief Map of the normSquare()
-    ///of a Point map
+    ///\brief Map of the \ref Point::normSquare() "normSquare()"
+    ///of a \ref Point "Point"-map
     ///
     ///Map of the \ref Point::normSquare() "normSquare()"
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 39)
+++ lemon/list_graph.h	(revision 2)
@@ -1,18 +1,0 @@
-/* -*- C++ -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2003-2008
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 44)
+++ lemon/maps.h	(revision 45)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -164,18 +164,20 @@
   ///you can specify a default value different from \c Value().
   template <typename K, typename T, typename Compare = std::less<K> >
-  class StdMap {
+  class StdMap : public MapBase<K, T> {
     template <typename K1, typename T1, typename C1>
     friend class StdMap;
   public:
 
+    typedef MapBase<K, T> Parent;
+    ///\e
+    typedef typename Parent::Key Key;
+    ///\e
+    typedef typename Parent::Value Value;
+    ///\e
+    typedef T& Reference;
+    ///\e
+    typedef const T& ConstReference;
+
     typedef True ReferenceMapTag;
-    ///Key type
-    typedef K Key;
-    ///Value type
-    typedef T Value;
-    ///Reference Type
-    typedef T& Reference;
-    ///Const reference type
-    typedef const T& ConstReference;
 
   private:
@@ -240,4 +242,25 @@
 
   };
+  
+  ///Returns a \ref StdMap class
+
+  ///This function just returns a \ref StdMap class with specified 
+  ///default value.
+  ///\relates StdMap
+  template<typename K, typename V, typename Compare = std::less<K> > 
+  inline StdMap<K, V, Compare> stdMap(const V& value = V()) {
+    return StdMap<K, V, Compare>(value);
+  }
+
+  ///Returns a \ref StdMap class created from an appropriate std::map
+
+  ///This function just returns a \ref StdMap class created from an 
+  ///appropriate std::map.
+  ///\relates StdMap
+  template<typename K, typename V, typename Compare = std::less<K> > 
+  inline StdMap<K, V, Compare> stdMap( const std::map<K, V, Compare> &map, 
+                                       const V& value = V() ) {
+    return StdMap<K, V, Compare>(map, value);
+  }
 
   /// \brief Map for storing values for keys from the range <tt>[0..size-1]</tt>
@@ -250,5 +273,5 @@
   /// \todo Revise its name
   template <typename T>
-  class IntegerMap {
+  class IntegerMap : public MapBase<int, T> {
 
     template <typename T1>
@@ -257,13 +280,15 @@
   public:
 
+    typedef MapBase<int, T> Parent;
+    ///\e
+    typedef typename Parent::Key Key;
+    ///\e
+    typedef typename Parent::Value Value;
+    ///\e
+    typedef T& Reference;
+    ///\e
+    typedef const T& ConstReference;
+
     typedef True ReferenceMapTag;
-    ///\e
-    typedef int Key;
-    ///\e
-    typedef T Value;
-    ///\e
-    typedef T& Reference;
-    ///\e
-    typedef const T& ConstReference;
 
   private:
@@ -314,4 +339,13 @@
 
   };
+  
+  ///Returns an \ref IntegerMap class
+
+  ///This function just returns an \ref IntegerMap class.
+  ///\relates IntegerMap
+  template<typename T>
+  inline IntegerMap<T> integerMap(int size = 0, const T& value = T()) {
+    return IntegerMap<T>(size, value);
+  }
 
   /// @}
@@ -406,4 +440,13 @@
     Value operator[](Key k) const {return m[k];}
   };
+  
+  ///Returns a \ref SimpleMap class
+
+  ///This function just returns a \ref SimpleMap class.
+  ///\relates SimpleMap
+  template<typename M>
+  inline SimpleMap<M> simpleMap(const M &m) {
+    return SimpleMap<M>(m);
+  }
 
   ///Simple writable wrapping of a map
@@ -433,4 +476,13 @@
     void set(Key k, const Value& c) { m.set(k, c); }
   };
+
+  ///Returns a \ref SimpleWriteMap class
+
+  ///This function just returns a \ref SimpleWriteMap class.
+  ///\relates SimpleWriteMap
+  template<typename M>
+  inline SimpleWriteMap<M> simpleWriteMap(M &m) {
+    return SimpleWriteMap<M>(m);
+  }
 
   ///Sum of two maps
Index: lemon/random.cc
===================================================================
--- lemon/random.cc	(revision 39)
+++ lemon/random.cc	(revision 16)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 39)
+++ lemon/random.h	(revision 23)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: lemon/tolerance.h
===================================================================
--- lemon/tolerance.h	(revision 42)
+++ lemon/tolerance.h	(revision 16)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2007
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -42,5 +42,5 @@
   ///
   ///This is an abstract class, it should be specialized for all numerical
-  ///data types. These specialized classes like Tolerance<double>
+  ///data types. These specialized classes like \ref Tolerance\<double\>
   ///may offer additional tuning parameters.
   ///
@@ -92,7 +92,7 @@
 
 
-  ///Float specialization of Tolerance.
-
-  ///Float specialization of Tolerance.
+  ///Float specialization of \ref Tolerance.
+
+  ///Float specialization of \ref Tolerance.
   ///\sa Tolerance
   ///\relates Tolerance
@@ -143,7 +143,7 @@
   };
 
-  ///Double specialization of Tolerance.
-
-  ///Double specialization of Tolerance.
+  ///Double specialization of \ref Tolerance.
+
+  ///Double specialization of \ref Tolerance.
   ///\sa Tolerance
   ///\relates Tolerance
@@ -194,7 +194,7 @@
   };
 
-  ///Long double specialization of Tolerance.
-
-  ///Long double specialization of Tolerance.
+  ///Long double specialization of \ref Tolerance.
+
+  ///Long double specialization of \ref Tolerance.
   ///\sa Tolerance
   ///\relates Tolerance
@@ -245,7 +245,7 @@
   };
 
-  ///Integer specialization of Tolerance.
-
-  ///Integer specialization of Tolerance.
+  ///Integer specialization of \ref Tolerance.
+
+  ///Integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -257,5 +257,5 @@
 
     ///\name Comparisons
-    ///See Tolerance for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -278,7 +278,7 @@
   };
 
-  ///Unsigned integer specialization of Tolerance.
-
   ///Unsigned integer specialization of \ref Tolerance.
+
+  ///Unsigned integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -290,5 +290,5 @@
 
     ///\name Comparisons
-    ///See Tolerance for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -312,7 +312,7 @@
   
 
-  ///Long integer specialization of Tolerance.
-
-  ///Long integer specialization of Tolerance.
+  ///Long integer specialization of \ref Tolerance.
+
+  ///Long integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -324,5 +324,5 @@
 
     ///\name Comparisons
-    ///See Tolerance for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -345,7 +345,7 @@
   };
 
-  ///Unsigned long integer specialization of Tolerance.
-
   ///Unsigned long integer specialization of \ref Tolerance.
+
+  ///Unsigned long integer specialization of \ref Tolerance.
   ///\sa Tolerance
   template<>
@@ -357,5 +357,5 @@
 
     ///\name Comparisons
-    ///See Tolerance for more details.
+    ///See \ref Tolerance for more details.
 
     ///@{
@@ -380,5 +380,5 @@
 #if defined __GNUC__ && !defined __STRICT_ANSI__
 
-  ///Long long integer specialization of Tolerance.
+  ///Long long integer specialization of \ref Tolerance.
 
   ///Long long integer specialization of \ref Tolerance.
@@ -415,5 +415,5 @@
   };
 
-  ///Unsigned long long integer specialization of Tolerance.
+  ///Unsigned long long integer specialization of \ref Tolerance.
 
   ///Unsigned long long integer specialization of \ref Tolerance.
